import * as i0 from '@angular/core';
import { Injectable, TemplateRef, Component, ViewEncapsulation, ViewChild, Input, ContentChild, Directive, Host, HostBinding, NgModule } from '@angular/core';
import { TourService, TourHotkeyListenerComponent } from 'ngx-ui-tour-core';
import { NgIf } from '@angular/common';
import { PopoverDirective } from 'ngx-bootstrap/popover';

class TourStepTemplateService {
}
TourStepTemplateService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: TourStepTemplateService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
TourStepTemplateService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: TourStepTemplateService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: TourStepTemplateService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class NgxbTourService extends TourService {
}
NgxbTourService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: NgxbTourService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
NgxbTourService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: NgxbTourService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: NgxbTourService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class TourStepTemplateComponent extends TourHotkeyListenerComponent {
    constructor(tourStepTemplateService, tourService) {
        super(tourService);
        this.tourStepTemplateService = tourStepTemplateService;
        this.tourService = tourService;
    }
    ngAfterContentInit() {
        this.tourStepTemplateService.template =
            this.stepTemplate ||
                this.stepTemplateContent ||
                this.defaultTourStepTemplate;
    }
}
TourStepTemplateComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: TourStepTemplateComponent, deps: [{ token: TourStepTemplateService }, { token: NgxbTourService }], target: i0.ɵɵFactoryTarget.Component });
TourStepTemplateComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.0.4", type: TourStepTemplateComponent, isStandalone: true, selector: "tour-step-template", inputs: { stepTemplate: "stepTemplate" }, queries: [{ propertyName: "stepTemplateContent", first: true, predicate: TemplateRef, descendants: true }], viewQueries: [{ propertyName: "defaultTourStepTemplate", first: true, predicate: ["tourStep"], descendants: true, read: TemplateRef, static: true }], usesInheritance: true, ngImport: i0, template: `
        <ng-template #tourStep let-step="step">
            <p class="tour-step-content" [innerHTML]="step?.content"></p>
            <div class="tour-step-navigation">
                <button
                    *ngIf="tourService.hasPrev(step)"
                    class="btn btn-sm btn-default"
                    (click)="tourService.prev()"
                >
                    « {{ step?.prevBtnTitle }}
                </button>
                <button
                    *ngIf="tourService.hasNext(step) && !step.nextOnAnchorClick"
                    class="btn btn-sm btn-default"
                    (click)="tourService.next()"
                >
                    {{ step?.nextBtnTitle }} »
                </button>
                <button class="btn btn-sm btn-default" (click)="tourService.end()">
                    {{ step?.endBtnTitle }}
                </button>
            </div>
        </ng-template>
    `, isInline: true, dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: TourStepTemplateComponent, decorators: [{
            type: Component,
            args: [{
                    encapsulation: ViewEncapsulation.None,
                    selector: 'tour-step-template',
                    template: `
        <ng-template #tourStep let-step="step">
            <p class="tour-step-content" [innerHTML]="step?.content"></p>
            <div class="tour-step-navigation">
                <button
                    *ngIf="tourService.hasPrev(step)"
                    class="btn btn-sm btn-default"
                    (click)="tourService.prev()"
                >
                    « {{ step?.prevBtnTitle }}
                </button>
                <button
                    *ngIf="tourService.hasNext(step) && !step.nextOnAnchorClick"
                    class="btn btn-sm btn-default"
                    (click)="tourService.next()"
                >
                    {{ step?.nextBtnTitle }} »
                </button>
                <button class="btn btn-sm btn-default" (click)="tourService.end()">
                    {{ step?.endBtnTitle }}
                </button>
            </div>
        </ng-template>
    `,
                    imports: [
                        NgIf
                    ],
                    standalone: true
                }]
        }], ctorParameters: function () { return [{ type: TourStepTemplateService }, { type: NgxbTourService }]; }, propDecorators: { defaultTourStepTemplate: [{
                type: ViewChild,
                args: ['tourStep', { read: TemplateRef, static: true }]
            }], stepTemplate: [{
                type: Input
            }], stepTemplateContent: [{
                type: ContentChild,
                args: [TemplateRef]
            }] } });

class TourAnchorNgxBootstrapPopoverDirective extends PopoverDirective {
}
TourAnchorNgxBootstrapPopoverDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: TourAnchorNgxBootstrapPopoverDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive });
TourAnchorNgxBootstrapPopoverDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.4", type: TourAnchorNgxBootstrapPopoverDirective, isStandalone: true, selector: "[tourAnchor]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: TourAnchorNgxBootstrapPopoverDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[tourAnchor]',
                    standalone: true
                }]
        }] });
class TourAnchorNgxBootstrapDirective {
    constructor(tourService, tourStepTemplate, element, popoverDirective) {
        this.tourService = tourService;
        this.tourStepTemplate = tourStepTemplate;
        this.element = element;
        this.popoverDirective = popoverDirective;
        this.popoverDirective.triggers = '';
    }
    ngOnInit() {
        this.tourService.register(this.tourAnchor, this);
    }
    ngOnDestroy() {
        this.tourService.unregister(this.tourAnchor);
    }
    // noinspection JSUnusedGlobalSymbols
    showTourStep(step) {
        this.isActive = true;
        this.popoverDirective.popover = this.tourStepTemplate.template;
        this.popoverDirective.popoverContext = { step };
        this.popoverDirective.popoverTitle = step.title;
        this.popoverDirective.container = 'body';
        this.popoverDirective.containerClass = 'ngx-bootstrap';
        if (step.containerClass) {
            this.popoverDirective.containerClass += ` ${step.containerClass}`;
        }
        this.popoverDirective.placement = step.placement || 'auto';
        this.popoverDirective.show();
    }
    // noinspection JSUnusedGlobalSymbols
    hideTourStep() {
        this.isActive = false;
        this.popoverDirective.hide();
    }
}
TourAnchorNgxBootstrapDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: TourAnchorNgxBootstrapDirective, deps: [{ token: NgxbTourService }, { token: TourStepTemplateService }, { token: i0.ElementRef }, { token: TourAnchorNgxBootstrapPopoverDirective, host: true }], target: i0.ɵɵFactoryTarget.Directive });
TourAnchorNgxBootstrapDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.0.4", type: TourAnchorNgxBootstrapDirective, isStandalone: true, selector: "[tourAnchor]", inputs: { tourAnchor: "tourAnchor" }, host: { properties: { "class.touranchor--is-active": "this.isActive" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: TourAnchorNgxBootstrapDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[tourAnchor]',
                    standalone: true
                }]
        }], ctorParameters: function () {
        return [{ type: NgxbTourService }, { type: TourStepTemplateService }, { type: i0.ElementRef }, { type: TourAnchorNgxBootstrapPopoverDirective, decorators: [{
                        type: Host
                    }] }];
    }, propDecorators: { tourAnchor: [{
                type: Input
            }], isActive: [{
                type: HostBinding,
                args: ['class.touranchor--is-active']
            }] } });

const COMPONENTS = [TourAnchorNgxBootstrapDirective, TourAnchorNgxBootstrapPopoverDirective, TourStepTemplateComponent];
class TourNgxBootstrapModule {
}
TourNgxBootstrapModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: TourNgxBootstrapModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
TourNgxBootstrapModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.4", ngImport: i0, type: TourNgxBootstrapModule, imports: [TourAnchorNgxBootstrapDirective, TourAnchorNgxBootstrapPopoverDirective, TourStepTemplateComponent], exports: [TourAnchorNgxBootstrapDirective, TourAnchorNgxBootstrapPopoverDirective, TourStepTemplateComponent] });
TourNgxBootstrapModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: TourNgxBootstrapModule, imports: [TourStepTemplateComponent] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.4", ngImport: i0, type: TourNgxBootstrapModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: COMPONENTS,
                    exports: COMPONENTS
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { TourAnchorNgxBootstrapDirective, TourAnchorNgxBootstrapPopoverDirective, TourNgxBootstrapModule, NgxbTourService as TourService, TourStepTemplateComponent };
//# sourceMappingURL=ngx-ui-tour-ngx-bootstrap.mjs.map
//# sourceMappingURL=ngx-ui-tour-ngx-bootstrap.mjs.map
